<?php

namespace App\Service\SnipContent;

use App\Entity\Snip;
use Symfony\Component\Routing\RouterInterface;

readonly class FlowChartTreeBuilder
{
    public function __construct(
        private RouterInterface $router,
    ) {}

    public function buildTree(Snip $snip): array
    {
        $tree = [];

        foreach ($snip->getSnipContents() as $content) {
            if ($content->getParent()) {
                $tree[] = sprintf('%s --> %s', $content->getParent(), $content);
            }
        }

        foreach ($snip->getSnipContents() as $content) {
            $tree[] = sprintf(
                'click %s href "%s"',
                $content,
                $this->router->generate('version_set', ['snip' => $snip->getId(), 'version' => $content->getId()])
            );
            $tree[] = sprintf('%s@{ shape: rounded }', $content);
        }

        $tree[] = sprintf('class %s active', $snip->getActiveVersion());

        return $tree;
    }
}